unit FMXWin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileCtrl, Grids, Outline, DirOutln, Tabs, ExtCtrls,
  FMXUtils, Menus, ShellAPI, JPEG, StrUtils, ComCtrls, ShellCtrls, Buttons;

type
  TFMForm = class(TForm)
    StatusBar: TPanel;
    DirectoryPanel: TPanel;
    FilePanel: TPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Move1: TMenuItem;
    Copy1: TMenuItem;
    Delete1: TMenuItem;
    Rename1: TMenuItem;
    Properties1: TMenuItem;
    N1: TMenuItem;
    ExitFM: TMenuItem;
    Floppy: TImage;
    Fixed: TImage;
    Network: TImage;
    CdRom: TImage;
    RamDrive: TImage;
    Splitter2: TSplitter;
    FileProperty: TPanel;
    Splitter3: TSplitter;
    PreviewImage: TImage;
    FileMange: TPanel;
    DriveTabSet: TTabSet;
    Splitter1: TSplitter;
    FileList: TFileListBox;
    FilePropertyTxt: TLabel;
    DirectoryOutline: TDirectoryListBox;
    Splitter4: TSplitter;
    EditPanel: TPanel;
    Splitter5: TSplitter;
    Address: TLabel;
    ShellComboBox: TShellComboBox;
    BitBtnOK: TBitBtn;
    procedure ExitFMClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DriveTabSetClick(Sender: TObject);
    procedure FileListChange(Sender: TObject);
    procedure DriveTabSetMeasureTab(Sender: TObject; Index: Integer;
      var TabWidth: Integer);
    procedure DriveTabSetDrawTab(Sender: TObject; TabCanvas: TCanvas;
      R: TRect; Index: Integer; Selected: Boolean);
    procedure File1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Properties1Click(Sender: TObject);
    procedure ConfirmChange(const ACaption, FromFile, ToFile: string);
    procedure FileChange(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure DirectoryOutlineChange(Sender: TObject);
    procedure FileListMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DirectoryOutlineDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure DirectoryOutlineDragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure FileListEndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure ShellComboBoxChange(Sender: TObject);
    procedure FormResize(Sender: TObject);

  private
   { Dclarations prives }
  public
    { Dclarations publiques }
end;

function OctetToSize(Octet: Integer): String;

var
  FMForm: TFMForm;

implementation

uses FAttrDlg, FChDlg;

{$R *.dfm}

procedure TFMForm.ExitFMClick(Sender: TObject);
begin
  Close;
end;

procedure TFMForm.FormCreate(Sender: TObject);
var
  Drive: Char;
  AddedIndex: Integer;
begin
  for Drive := 'A' to 'Z' do //iteration de tout les lecteurs possibles
  begin
    case GetDriveType(PChar(Drive + ':\')) of //> 1 si lecteur correct
    DRIVE_REMOVABLE: //floppy
      AddedIndex := DriveTabSet.Tabs.AddObject(Drive, Floppy.Picture.graphic);
    DRIVE_FIXED: //fixed
      AddedIndex := DriveTabSet.Tabs.AddObject(Drive, Fixed.Picture.Graphic);
    DRIVE_REMOTE: //reseau
      AddedIndex := DriveTabSet.Tabs.AddObject(Drive, Network.Picture.Graphic);
    DRIVE_CDROM: //cdrom
      AddedIndex := DriveTabSet.Tabs.AddObject(Drive, CdRom.Picture.Graphic);
    DRIVE_RAMDISK: //ramdrive
      AddedIndex := DriveTabSet.Tabs.AddObject(Drive, RamDrive.Picture.Graphic);
    end;
    if UpCase(Drive) = UpCase(DirectoryOutline.Drive) then   //si lecteur actif...
      DriveTabSet.TabIndex := AddedIndex;     //...en faire l'onglet actif
   end;
   DirectoryPanel.Caption := DirectoryOutline.Directory;
   ShellComboBox.Path := DirectoryOutline.Directory;
end;

procedure TFMForm.DriveTabSetClick(Sender: TObject);
begin
  with DriveTabSet do
    DirectoryOutline.Drive := Tabs[TabIndex][1];
end;

procedure TFMForm.FileListChange(Sender: TObject);
var
  TheFileName: string;
  FType: string;
  Pos: Integer;
  SelDir, Str1, Str2, Attrib: string;
  Attribut: Word;
begin
  with FileList do
  begin
    if ItemIndex > -1 then  //un element est-il selectionner
    begin
      Pos := LastDelimiter('\', FileName);
      Str1 := Copy(FileName, 1, Pos);
      Str2 := Copy(FileName, Pos+2, Length(FileName)-2-Pos);
      SelDir := Str1+Str2;
      PreviewImage.Visible := False;

      if FileExists(FileName) then
      begin
        TheFileName := Items[ItemIndex]; //chercher le nom du fichier
        FilePanel.Caption := TheFileName+' '+OctetToSize(GetFileSize(TheFileName));
        Attribut := FileGetAttr(FileName);
        Attrib := 'normal';
        if (Attribut and faSysFile) = faSysFile then
          Attrib := 'System';
        if (Attribut and faHidden) = faHidden then
          if Attrib = 'System' then
            Attrib := Attrib+', Hide'
          else
            Attrib := 'Hide';

        FilePropertyTxt.Caption := ' '+FileList.Items[FileList.ItemIndex]+#13#10+
          ' '+#13#10#10+
          ' Modifie le : '+DateTimeToStr(FileDateTime(FileList.FileName))+#13#10#10+
          ' Taille : '+OctetToSize(GetFileSize(FileName))+#13#10#10+
          ' Attributs : ('+Attrib+')';

        Pos := LastDelimiter('.', FileName);
        FType := Copy(FileName, Pos+1, Length(FileName));
        if (FType = 'bmp') or (FType = 'jpg') or (FType = 'jpeg') then
        begin
           PreviewImage.Visible := True;
           PreviewImage.Picture.LoadFromFile(FileName);
        end;
      end
      else if DirectoryExists(SelDir) then
      begin
        Pos := LastDelimiter('\', SelDir);
        FilePropertyTxt.Caption := ' '+Copy(SelDir, Pos+1, Length(SelDir))+#13#10+
          ' Dosier de fichiers'+#13#10#10+
          ' Modifie le : '{+DateTimeToStr(FileDateTime(FileName))}+#13#10#10+
          ' Attributs : ('+Attrib+')';
      end;
    end;
  end;
end;

procedure TFMForm.DriveTabSetMeasureTab(Sender: TObject; Index: Integer; var TabWidth: Integer);
var
  BitmapWidth: Integer;
begin
  BitmapWidth := TBitmap(DriveTabSet.Tabs.Objects[Index]).Width;
  //augmenter la largeur de l'onglet de celle de l'image bitmap + 2
  Inc(TabWidth, 2 + BitmapWidth);
end;

procedure TFMForm.DriveTabSetDrawTab(Sender: TObject; TabCanvas: TCanvas; R: TRect; Index: Integer; Selected: Boolean);
var
  Bitmap: TBitmap;
begin
  Bitmap := TBitmap(DriveTabSet.Tabs.Objects[Index]);
  with TabCanvas do
  begin
    Draw(R.Left, R.Top + 4, Bitmap);   //dessin du bitmap
    TextOut(R.Left + 2 + Bitmap.Width, R.Top + 2, DriveTabSet.Tabs[Index]); //dessin du test
  end;
end;

procedure TFMForm.File1Click(Sender: TObject);
var
  FileSelected: Boolean;
begin
  FileSelected := FileList.ItemIndex >= 0; //vrai si un fichier est selectionner
  Open1.Enabled := FileSelected;
  Delete1.Enabled := FileSelected;
  Copy1.Enabled := FileSelected;
  Move1.Enabled := FileSelected;
  Rename1.Enabled := FileSelected;
  Properties1.Enabled := FileSelected;
end;

procedure TFMForm.Delete1Click(Sender: TObject);
begin
  with FileList do
    if MessageDlg('Delete '+FileName+' ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      if DeleteFile(FileName) then Update;
end;

procedure TFMForm.Properties1Click(Sender: TObject);
var
  Attribut, NewAttributes: Word;
begin
  with FileAttrForm do
  begin
    FileName.Caption := FileList.Items[FileList.ItemIndex]; //libelle de la boite
    FilePath.Caption := FileList.Directory; //montrer le nom du repertoire
    ChangeDate.Caption := DateTimeToStr(FileDateTime(FileList.FileName));
    Attribut := FileGetAttr(FileName.Caption); //lire les attributs du fichier
    ReadOnly.Checked := (Attribut and faReadOnly) = faReadOnly;
    Archive.Checked := (Attribut and faArchive) = faArchive;
    System.Checked := (Attribut and faSysFile) = faSysFile;
    Hidden.Checked := (Attribut and faHidden) = faHidden;
    if ShowModal <> mrCancel then  //execute la boite de dialogue
    begin
      NewAttributes := Attribut; //demarer avec les attributs originaux
      if ReadOnly.Checked then NewAttributes := NewAttributes or faReadOnly
      else NewAttributes := NewAttributes and not faReadOnly;
      if Archive.Checked then NewAttributes := NewAttributes or faArchive
      else NewAttributes := NewAttributes and not faArchive;
      if System.Checked then NewAttributes := NewAttributes or faSysFile
      else NewAttributes := NewAttributes and not faSysFile;
      if Hidden.Checked then NewAttributes := NewAttributes or faHidden
      else NewAttributes := NewAttributes and not faHidden;
      if NewAttributes <> Attribut then            //en cas de changement ...
        FileSetAttr(FileName.Caption, NewAttributes); //...ecrire les nouvelle valeur
    end;
    FileListChange(Sender);
  end;
end;

procedure TFMForm.ConfirmChange(const ACaption, FromFile, ToFile: string);
begin
  if MessageDlg(Format('%s %s to %s ?', [ACaption, FromFile, ToFile]), mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    if ACaption = 'Move' then
      MoveFile(FromFile, ToFile)
    else if ACaption = 'Copy' then
      CopyFile(FromFile, ToFile)
    else if ACaption = 'Rename' then
      RenameFile(FromFile, ToFile);
    FileList.Update;
  end;
end;

procedure TFMForm.FileChange(Sender: TObject);
begin
  with ChangeDlg do
  begin
    if Sender = Move1 then Caption := 'Move'
    else if Sender = Copy1 then Caption := 'Copy'
    else if Sender = Rename1 then Caption := 'Rename'
    else Exit;
    CurrentDir.Caption := DirectoryOutline.Directory;
    FromFileName.Text := FileList.FileName;
    ToFileName.Text := '';
    if (ShowModal <> mrCancel) and (ToFileName.Text <> '') then
      ConfirmChange(Caption, FromFileName.Text, ToFileName.Text);
  end;
end;

procedure TFMForm.Open1Click(Sender: TObject);
  var
    SelDir, Str1, Str2: string;
    Pos: Integer;
    ExeError: Cardinal;
begin
  with FileList do
  begin
    Pos := LastDelimiter('\', FileName);
    Str1 := Copy(FileName, 1, Pos);
    Str2 := Copy(FileName, Pos+2, Length(FileName)-2-Pos);
    SelDir := Str1+Str2;
    if DirectoryExists(SelDir) then
      DirectoryOutline.Directory := SelDir
    else
    begin
      ExeError := ExecuteFile(FileName, '', Directory, SW_SHOW);
      if ExeError = 31 then
        ShellExecute(Application.Handle, 'open', PChar('rundll32.exe'), PChar('shell32.dll, OpenAs_RunDLL '+FileName), nil, SW_SHOW);
    end;
  end;
end;

procedure TFMForm.DirectoryOutlineChange(Sender: TObject);
begin
  with DirectoryOutline do
  begin
    OpenCurrent ;
    ShellComboBox.Path := Directory;
    DirectoryPanel.Caption := Directory;
  end;
end;

procedure TFMForm.FileListMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then        //ne glisser que si le bouton gauche enfoncer
    with Sender as TFileListBox do  //traiter sender comme TListBox
    begin
      if ItemAtPos(Point(X, Y), True) >= 0 then //y a-t-il un element ici ?
        BeginDrag(False);           //si oui, le faire glisser
    end;
end;

procedure TFMForm.DirectoryOutlineDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  if Source is TFileListBox then
    Accept := True;
end;

procedure TFMForm.DirectoryOutlineDragDrop(Sender, Source: TObject; X, Y: Integer);
  var
   APoint: TPoint;
   Tofile: string;
begin
  if Source is TFileListBox then
    with DirectoryOutLine do
    begin
      APoint.X:=X;
      APoint.Y:=Y;
      Tofile := GetItemPath(ItemAtPos(APoint, True));
      if RightStr(Tofile,1) <> '\' then
        Tofile := Tofile + '\'+ Extractfilename(Filelist.FileName)
      else
        Tofile := Tofile + Extractfilename(Filelist.FileName);
      ConfirmChange('Move', FileList.FileName, Tofile);
    end;
end;

procedure TFMForm.FileListEndDrag(Sender, Target: TObject; X, Y: Integer);
begin
  if Target <> nil then FileList.Update;
end;

procedure TFMForm.ShellComboBoxChange(Sender: TObject);
begin
  FileList.Directory := ShellComboBox.Path;
  FileList.Update;
  DirectoryOutline.Directory := ShellComboBox.Path;
end;

procedure TFMForm.FormResize(Sender: TObject);
begin
  BitBtnOk.Left := Width-64;
  ShellComboBox.Width := Width-113;
end;

function OctetToSize(Octet: Integer): String;
var
  Units: String;
  SizeOctet: Extended;
begin
  SizeOctet := Octet;
  Units := ' Octets';
  if SizeOctet > 1024 then
  begin
    SizeOctet := SizeOctet / 1024;
    Units := ' KOctets'
  end;
  if SizeOctet > 1024 then
  begin
    SizeOctet := SizeOctet / 1024;
    Units := ' MOctets'
  end;
  if SizeOctet > 1024 then
  begin
    SizeOctet := SizeOctet / 1024;
    Units := ' GOctets'
  end;
  if SizeOctet > 1024 then
  begin
    SizeOctet := SizeOctet / 1024;
    Units := ' TOctets'
  end;

  Result := FloatToStr(SizeOctet)+Units;
end;
end.
